#include<bits/stdc++.h>

using namespace std;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int n, b = 0;
  cin >> n;
  vector<int> va(n), vb(n);
  for (int i = 0; i < n; i++)
    cin >> va[i];
  for (int i = 0; i < n; i++)
    cin >> vb[i];
  bool a = true;
  for (int i = 0; i < n; i++) {
    if (va[i] != 1) {
      a = false;
      break;
    }
  }
  if (a) {
    cout << *max_element(vb.begin(), vb.end());
    return 0;
  }
  for (int i = 0; i < n; i++) {
    int xc = va[i], ac = vb[i], bc = xc * ac;
    b = max(bc, b);
    for (int j = i + 1; j < n; j++) {
      xc ^= va[j];
      ac &= vb[j];
      bc = xc * ac;
      b = max(bc, b);
    }
  }
  cout << b;
  return 0;
}